const sync = require('./sync');

function generateRandomNumber(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}

function getVariation(uuid, experiment){
    let random = generateRandomNumber(0, 100);
    let variation = experiment.variations.filter(variation => {
        return random >= variation.rangeStart && random <= variation.rangeEnd;
    })

    return variation[0].id;
}

function handle(req, res) {
    let allExperiments = {
        "AwesomeExperiment1": {
            variations: [
                {
                    id: generateRandomNumber(1, 10000),
                    rangeStart: 0,
                    rangeEnd: 50,
                },
                {
                    id: generateRandomNumber(1, 10000),
                    rangeStart: 50,
                    rangeEnd: 100,
                },
            ],
        },
        "AwesomeExperiment2": {
            variations: [
                {
                    id: generateRandomNumber(1, 10000),
                    rangeStart: 0,
                    rangeEnd: 50,
                },
                {
                    id: generateRandomNumber(1, 10000),
                    rangeStart: 50,
                    rangeEnd: 100,
                },
            ],
        },
        "AwesomeExperiment3": {
            variations: [
                {
                    id: generateRandomNumber(1, 10000),
                    rangeStart: 0,
                    rangeEnd: 50,
                },
                {
                    id: generateRandomNumber(1, 10000),
                    rangeStart: 50,
                    rangeEnd: 100,
                },
            ],
        },
        },
        availableExperiments = {},
        uuid = generateRandomNumber(1, 5000);

    for(let experiment in allExperiments){
        availableExperiments[experiment] = getVariation(uuid, allExperiments[experiment]);
    }

    return availableExperiments;
};


module.exports = function(/**Configs*/configs){
    if (!configs || typeof configs !== 'object') {
        throw new Error('You should pass config object');
    }
    else if (!configs.tags) {
        throw new Error('You should pass env');
    }
    else if (!configs.apiEndpoint) {
        throw new Error('You should pass API_ENDPOINT');
    }

    handle.ready = () => sync.load(configs);
    return handle;
};
